/*
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License along
 with this program; if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */


#ifndef _scoreeditor_
#define _scoreeditor_

#include "Editors/Editor.h"

#include <vector>

namespace AriaMaestosa {
	
struct NoteDest
{
	int line;
	int sign;
};
	
class ScoreEditor : public Editor
{
	
	NoteDest noteDestChart[128];
	
public:
    
    ScoreEditor(Track* track);
    
    void render(int mousex_current=-1, int mousey_current=-1, int mousex_initial=-1, int mousey_initial=-1, bool focus=false);
    
    void updatePosition(const int from_y, const int to_y, const int width, const int height, const int barHeight);
    
    void mouseDown(const int x, const int y);
    void mouseDrag(const int mousex_current, const int mousey_current, const int mousex_initial, const int mousey_initial);
    void mouseUp(const int mousex_current, const int mousey_current, const int mousex_initial, const int mousey_initial);
    void rightClick(const int x, const int y);
    
    int getYScrollInPixels();
    void drawNote(int note_x, int string, bool open, int tail_type, int tail_amount, bool pointed, int sign);
		
	void updateNoteDestChart();
	
    ~ScoreEditor();
};

}

#endif
